﻿package{
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.events.FullScreenEvent;
	import flash.events.MouseEvent;
	import flash.geom.Point;
	import flash.utils.setInterval;
	import flash.display.LineScaleMode;
	import flash.display.CapsStyle;
	import flash.display.Shape;

	public class Liner extends Sprite {
		public 	var balls:Array;
		public 	var plus:Number = 1;
		public 	var vario:Shape;
		public 	var thick:Number = 1;
		private var actual_pt:Point;


		public function Liner() {
			balls = new Array();
			addEventListener(Event.ADDED_TO_STAGE,addedHandler);
		}

		private function addedHandler(e:Event):void {
			stage.addEventListener(FullScreenEvent.FULL_SCREEN,fullhandler);
			setInterval(buildScreen,10);
			stage.addEventListener(MouseEvent.MOUSE_DOWN,Down);
			stage.addEventListener(MouseEvent.MOUSE_UP,clickHandler);
			stage.doubleClickEnabled=true;
			
		}
		private function fullhandler(e:FullScreenEvent):void {
			balls = new Array();
		}
		

		private function Down(e:MouseEvent):void {
			actual_pt=new Point(e.stageX,e.stageY);
			vario = new Shape();
			stage.addChild(vario);
			addEventListener(Event.ENTER_FRAME,drawVario);
		}
		

		private function drawVario(e:Event):void {
			vario.graphics.clear();
			vario.graphics.lineStyle(2, 0xffffff,.6);
			vario.graphics.drawCircle(vario.parent.globalToLocal(actual_pt).x, vario.parent.globalToLocal(actual_pt).y, plus);
			plus++;
		}
		private function clickHandler(e:MouseEvent):void {
			removeEventListener(Event.ENTER_FRAME,drawVario);
			
			if (vario != null) stage.removeChild(vario);
			var pt:Point=new Point(e.stageX,e.stageY);
			var obj:Object={"posx":this.globalToLocal(pt).x,"posy":this.globalToLocal(pt).y,"angle":0,"rayon":plus,"centerY":this.globalToLocal(pt).y,"centerX":this.globalToLocal(pt).x};
			balls.push(obj);
			//balls.sortOn(["posx"],[Array.NUMERIC]);
			plus = 1;
		}
		
		private function buildScreen():void {
			this.graphics.clear();
			for (var i:Number = 0; i<balls.length; i++) {
				//var tailleRect:Number= 50*i;
				var tailleRect:Number=50;

				//graphics.beginFill(0xffffff,.4);
				//graphics.drawRect(balls[i].centerX-(balls[i].rayon/2), balls[i].centerY-(balls[i].rayon/2), balls[i].rayon, balls[i].rayon);
				//graphics.endFill();

				balls[i].posy=balls[i].centerY+Math.sin(balls[i].angle*Math.PI/180)*balls[i].rayon;
				balls[i].posx=balls[i].centerX+Math.cos(balls[i].angle*Math.PI/180)*balls[i].rayon;

				graphics.lineStyle(1+balls[i].posx/50,0x1446C8,.8,true,LineScaleMode.NORMAL,CapsStyle.ROUND);
				//draw the lines
				if (i>0) {
					graphics.moveTo(balls[i-1].posx,balls[i-1].posy);
					graphics.lineTo(balls[i].posx,balls[i].posy);
					graphics.lineStyle(2,0xffffff,.6,true,LineScaleMode.NORMAL,CapsStyle.ROUND);
					graphics.moveTo(balls[i].posx,balls[i].posy);
					graphics.lineTo(balls[i].centerX, balls[i].centerY);
					graphics.moveTo(balls[i].posx,balls[i].posy);
					graphics.lineTo(balls[i].centerX, balls[i].centerY);
				}
				graphics.lineStyle();
				//set the new position

				//trace(balls[i].posx);


				// création du carré après avoir calculé la position posx et posy
				//graphics.beginFill(0xffffff,.4);
				//graphics.drawRect(balls[i].centerX-(balls[i].rayon),balls[i].centerY-(balls[i].rayon), (Math.sin(45)*balls[i].rayon)*2, (Math.sin(45)*balls[i].rayon)*2);
				graphics.lineStyle(2,0xffffff,.5);
				graphics.drawCircle(balls[i].centerX, balls[i].centerY, balls[i].rayon);
				graphics.lineStyle(2,0xE6FF00,.4);
				//graphics.lineGradientStyle(GradientType.RADIAL, [0xFF0000, 0xff0000, 0x000000], [1, 1, 1], [0, 128, 255], gradientBoxMatrix);
				graphics.drawCircle(balls[i].centerX+Math.cos(balls[i].angle*Math.PI/180)*balls[i].rayon,balls[i].centerY+Math.sin(balls[i].angle*Math.PI/180)*balls[i].rayon,2);
				graphics.endFill();
				balls[i].angle+=5;
			}
		}
	}
}